---
title: 'Slottable: assignedSlot'
slug: Web/API/Slottable/assignedSlot
tags:
  - API
  - Property
  - Reference
  - Slottable
  - Web Components
  - assignedSlot
  - shadow dom
---
<p>{{APIRef("Shadow DOM")}}</p>

<p><span class="seoSummary">The <strong><code>assignedSlot</code></strong> read-only property of the {{domxref("Slottable")}} interface returns an {{domxref("HTMLSlotElement")}} representing the {{htmlelement("slot")}} element the node is inserted in.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var slotElement = elementInstance.assignedSlot</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref('HTMLSlotElement')}} instance, or <code>null</code> if the element is not assigned to a slot, or if the associated shadow root was attached with its {{domxref("ShadowRoot.mode", "mode")}} set to <code>closed</code> (see {{domxref("Element.attachShadow")}} for further details).</p>

<h2 id="Example">Examples</h2>

<p>In our <a href="https://github.com/mdn/web-components-examples/tree/master/simple-template">simple-template example</a> (<a href="https://mdn.github.io/web-components-examples/simple-template/">see it live</a>), we create a trivial custom element example called <code>&lt;my-paragraph&gt;</code> in which a shadow root is attached and then populated using the contents of a template that contains a slot named <code>my-text</code>.</p>

<p>When <code>&lt;my-paragraph&gt;</code> is used in the document, the slot is populated by a slottable element by including it inside the element with a <code><a href="/en-US/docs/Web/HTML/Global_attributes/slot">slot</a></code> attribute with the value <code>my-text</code>. Here is one such example:</p>

<pre class="brush: html notranslate">&lt;my-paragraph&gt;
  &lt;span slot="my-text"&gt;Let's have some different text!&lt;/span&gt;
&lt;/my-paragraph&gt;</pre>

<p>In our JavaScript file we get a reference to the {{htmlelement("span")}} shown above, then log a reference to the original <code>&lt;slot&gt;</code> element the <code>&lt;span&gt;</code> was inserted in.</p>

<pre class="brush: js notranslate">let slottedSpan = document.querySelector('my-paragraph span')
console.log(slottedSpan.assignedSlot); // logs '<span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="objectBox objectBox-node"><span class="angleBracket">&lt;</span><span class="tag-name">slot</span> <span><span class="attrName">name</span><span class="attrEqual">=</span><span class="attrValue objectBox objectBox-string">"my-text"</span></span><span class="angleBracket">&gt;'</span></span></span></span></span></pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG','#dom-slotable-assignedslot','assignedSlot')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<p>{{Compat("api.Slottable.assignedSlot")}}</p>
